import { ComponentFactory, VNode } from 'preact'
import { Handler, ErrorHandler, PushEvent } from './baseTypes'
import { Aperture } from './observable'
export interface State {
    replace?: boolean
    props: object
    renderEffect: boolean
    children: VNode | null
}
export interface Config<P, E> {
    handler?: Handler<P, E, any>
    errorHandler?: ErrorHandler<P, any>
}
export declare const withEffects: <P, E, CP = P>(
    aperture: Aperture<P, E, any>,
    config?: Config<P, E>
) => (
    BaseComponent?: ComponentFactory<
        CP & {
            pushEvent: PushEvent
        }
    >
) => ComponentFactory<P>
